#include "DemoApp1.h"
#include "WLayoutWindow.h"
#include "WPanel.h"

App::App() : BApplication('iGOO')
{
	//----------------------------------------------------------------------
	// Java N E S W type layout
	//----------------------------------------------------------------------
	
	BRect r(75,75,200,200);	
	WLayoutWindow *Window = new WLayoutWindow(r,"FrameLayout");
	
	r.OffsetTo(0,0);
	WPanel *topHeader = new WPanel(r,"topHdr");
	WPanel *botHeader = new WPanel(r,"botHdr");
	WPanel *topLView = new WPanel(r,"topLView");
	WPanel *botLView = new WPanel(r,"botLView");
	WPanel *topRView = new WPanel(r,"topRView");
	WPanel *botRView = new WPanel(r,"botRView");

	Window->AddChild(topLView);
	Window->AddChild(botLView);
	Window->AddChild(topRView);
	Window->AddChild(botRView);
	Window->AddChild(topHeader);
	Window->AddChild(botHeader);
	
	WFrame *topFrame = new WFrame;
	topFrame->Set(EDGE_TOP,USE_PARENT, USE_LITERAL, 0);
	topFrame->Set(EDGE_LEFT,USE_PARENT, USE_LITERAL, 0);
	topFrame->Set(EDGE_RIGHT,USE_PARENT, USE_PERCENT, 100);
	topFrame->Set(EDGE_BOTTOM,USE_DELTA,20);
	Window->manager->Manage(topHeader,topFrame);
	
	WFrame *botFrame = new WFrame;
	botFrame->Set(EDGE_TOP,USE_DELTA, -20);
	botFrame->Set(EDGE_LEFT,USE_PARENT,USE_LITERAL,0);
	botFrame->Set(EDGE_RIGHT,USE_PARENT,USE_PERCENT,100);
	botFrame->Set(EDGE_BOTTOM,USE_PARENT,USE_PERCENT, 100);
	Window->manager->Manage(botHeader,botFrame);
	
	WFrame *topLframe = new WFrame;
	topLframe->Set(EDGE_TOP,USE_SIBLING, topHeader, EDGE_ADJACENT,0);
	topLframe->Set(EDGE_LEFT,USE_PARENT,USE_LITERAL,0);
	topLframe->Set(EDGE_RIGHT,USE_PARENT,USE_PERCENT,50);
	topLframe->Set(EDGE_BOTTOM,USE_PARENT,USE_PERCENT,50);
	Window->manager->Manage(topLView, topLframe);
	
	WFrame *botLframe = new WFrame;
	botLframe->Set(EDGE_TOP,USE_SIBLING,topLView,EDGE_ADJACENT,0);
	botLframe->Set(EDGE_LEFT,USE_PARENT,USE_LITERAL,0);
	botLframe->Set(EDGE_RIGHT,USE_PARENT,USE_PERCENT,50);
	botLframe->Set(EDGE_BOTTOM,USE_SIBLING,botHeader,EDGE_ADJACENT,0);
	Window->manager->Manage(botLView, botLframe);
	
	WFrame *topRframe = new WFrame;
	topRframe->Set(EDGE_TOP,USE_SIBLING,topHeader,EDGE_ADJACENT,0);
	topRframe->Set(EDGE_LEFT,USE_SIBLING,topLView,EDGE_ADJACENT,0);
	topRframe->Set(EDGE_RIGHT,USE_PARENT,USE_PERCENT,100);
	topRframe->Set(EDGE_BOTTOM,USE_PARENT,USE_PERCENT,50);
	Window->manager->Manage(topRView, topRframe);
	
	WFrame *botRframe = new WFrame;
	botRframe->Set(EDGE_TOP,USE_SIBLING,topRView,EDGE_ADJACENT,0);
	botRframe->Set(EDGE_LEFT,USE_SIBLING,botLView,EDGE_ADJACENT,0);
	botRframe->Set(EDGE_RIGHT,USE_PARENT,USE_PERCENT,100);
	botRframe->Set(EDGE_BOTTOM,USE_SIBLING,botHeader,EDGE_ADJACENT,0);
	Window->manager->Manage(botRView, botRframe);
	
	Window->manager->Layout(Window->Bounds());
	Window->Show();
}

App::~App()
{}

int main()
{
	App myApp;
	myApp.Run();
	return(0);
}