// WPanel
// Copyright 1998, William Bull

#undef DEBUG_PANEL

#include "WPanel.h"

WPanel::WPanel(BRect r,
			  const char* name,
			  ulong style,
			  ulong flags)
		: BView(r, name, B_FOLLOW_NONE, flags | B_WILL_DRAW | B_FRAME_EVENTS | B_FULL_UPDATE_ON_RESIZE)
{
	#ifdef DEBUG_PANEL
		printf("@@ WPanel constructor called\n");
	#endif
	_style = style;
	

	SetViewColor(B_TRANSPARENT_32_BIT);
	
	if (_style == PANEL_RAISED) {
		bkg_color.red = 230;
		bkg_color.green = 230;
		bkg_color.blue = 230;
	}
	else bkg_color = B_TRANSPARENT_32_BIT;
}

WPanel::~WPanel()
{
	#ifdef DEBUG_PANEL
		printf("@@ WPanel destructor called\n");
	#endif
}

void WPanel::Draw(BRect clip)
{
		
	#ifdef DEBUG_PANEL
		printf("@@ Draw called (%s)\n", Name());
	#endif
	
	if (Window()->Lock()) {
		if (_style == PANEL_RAISED) {
			BRect r(0,0,Bounds().right, Bounds().bottom);
			SetHighColor(bkg_color);
			FillRect(r);
			SetHighColor(255,255,255);
			StrokeLine(BPoint(r.left,r.top), BPoint(r.right-1,r.top));
			StrokeLine(BPoint(r.left,r.top+1), BPoint(r.left,r.bottom));
			SetHighColor(180,180,180);
			StrokeLine(BPoint(r.left,r.bottom),BPoint(r.right,r.bottom));
			StrokeLine(BPoint(r.right,r.top),BPoint(r.right,r.bottom));
		}
		else if (_style == PANEL_DEPRESSED) {
			BRect r(0,0,Bounds().right, Bounds().bottom);
			SetHighColor(180,180,180);
			StrokeLine(BPoint(r.left,r.top), BPoint(r.right-1,r.top));
			StrokeLine(BPoint(r.left,r.top+1), BPoint(r.left,r.bottom-1));
			SetHighColor(220,220,220);
			StrokeLine(BPoint(r.left+1,r.top+1), BPoint(r.right-2,r.top+1));
			StrokeLine(BPoint(r.left+1,r.top+2), BPoint(r.left+1,r.bottom-2));
			SetHighColor(255,255,255);
			r.InsetBy(2,2);
			FillRect(r);
		}
		Sync();
		Window()->Unlock();
	}
}